﻿var Popu=new function(){

	this.getLocalizedString= function(StrXML,localizedCode,defaultStr){
		var s,ls;
		if (StrXML !=""){
			s=Popu.getStringBetween(StrXML,"<"+localizedCode+">","</"+localizedCode+">").replace("'","&#39;").replace(/^.*?(<|>).*?$/,"");
			if (s!="") {return s;}
		}
		return defaultStr;
	}

	this.getStringBetween= function(s,s1,s2){
		var re = new RegExp(s1+".*?"+s2, "");
		var mts = s.match(re);
		if (mts != null){
			if(mts.length>0){
				return mts[0].replace(s1,"").replace(s2,"");
			}else{return "";}
		}else{
			return "";
		}
	}

	//停靠状态
	this.checkState=function(){
		var imgBackground = document.getElementById("imgBackground");
    	if (System.Gadget.docked){
    		document.body.style.width="130px";
    		document.body.style.height="127px";
    		imgBackground.style.width="130px";
    		imgBackground.style.height="127px";
    		document.getElementById("pagebody").className="docked";
    		if(haveUpdate){
    			imgBackground.src = "url(images/background_update.png)";
    		}else{
    			imgBackground.src = "url(images/background.png)";
    		}
    		NextBillionTime.top=88;
    		NextBillionTime.left=62;
    		NextBillionTime.fontsize=11;
    		NextBillionTitle.top=73;
    		NextBillionTitle.left=62;
    		NextBillionTitle.fontsize=11;
    		tooltip.top=110;
    		tooltip.left=62;
    		tooltip.fontsize=11;
    		dock=0;
    	}else{
    		document.body.style.width="224px";
    		document.body.style.height="224px";
    		imgBackground.style.width="224px";
    		imgBackground.style.height="224px";
    		document.getElementById("pagebody").className="undocked";
    		if(haveUpdate){
    			imgBackground.src = "url(images/background_undock_update.png)";
    		}else{
	    		imgBackground.src = "url(images/background_undock.png)";
	    	}
	    	NextBillionTime.top=160;
    		NextBillionTime.left=110;
    		NextBillionTime.fontsize=14;
    		NextBillionTitle.top=138;
    		NextBillionTitle.left=110;
    		NextBillionTitle.fontsize=14;
    		tooltip.top=202;
    		tooltip.left=110;
    		tooltip.fontsize=14;

    		dock=1;
    	}
	}


	//更改事件

	//显示Tip
	this.HideTip= function(){
		tooltip.value=" ";
		document.getElementById("div_update").style.display="";
	}
	this.ShowTip= function(D){
		D=D.replace(/&#1239;/g,'&#39;');
		tooltip.value=D.replace('&#39;','\'');
		document.getElementById("div_update").style.display="none";
	}
	this.ShowWeblinkTip= function(){
		tooltip.value=L_localizedStrings_moregadget.replace('&#39;','\'');
		document.getElementById("div_update").style.display="none";
	}
	this.ShowPopulationTip= function(){
		tooltip.value=L_localizedStrings_Population.replace('&#39;','\'');
		document.getElementById("div_update").style.display="none";
	}
	this.ShowCountryAreaTip= function(){
		tooltip.value=L_localizedStrings_CountryArea.replace('&#39;','\'');
		document.getElementById("div_update").style.display="none";
	}


	//显示flyout
	this.OpenFlyoutCountry= function(){
		try {
			System.Gadget.Flyout.file ="flyout_Country.html";
			System.Gadget.Flyout.show = true;
		} catch (err){}
	}

	this.OpenFlyoutInfo= function(){
		try {
			System.Gadget.Flyout.file ="flyout_info.html";
			System.Gadget.Flyout.show = true;
			//setTimeout("Popu.setFlyoutText();",300);
		} catch (err){}
	}
	this.setFlyoutText= function(){
		try {
			System.Gadget.Flyout.document.getElementById("web_link").href=L_localizedStrings_weblink+"?utm_source=Population&utm_medium=Fly";
			System.Gadget.Flyout.document.getElementById("Development").innerHTML = L_localizedStrings_Development;
		} catch (err){}
	}
	//存取设置
	this.SaveSetting= function(SettingName,value){
		try{
			System.Gadget.Settings.write(SettingName,value+1);
		}catch(err){}
	}
	this.ReadSetting= function(SettingName,Default){
		var value;
		try{
			value=System.Gadget.Settings.read(SettingName);
		}catch(err){value=Default+1;}
		if (!value) {value=Default;}
		else value-=1;
		return value;
	}
	
	//调入
	this.pageOnload= function(){
		try{
			Popu.IntGadgetObject();
			Popu.checkState();
			System.Gadget.onUndock = Popu.checkState; 
			System.Gadget.onDock = Popu.checkState;			
			//document.getElementById("div_update").innerText=System.Gadget.name;
		}catch(err){}
		
		document.getElementById("weblink").href=L_localizedStrings_weblink+"?utm_source=Population&utm_medium=Main";
		document.getElementById("weblink").title=L_localizedStrings_moregadget;
	//	document.getElementById("weblink").focus();
		document.getElementById("check_update").src = "http://gd.gadgetwe.com/programdata/PopulationCheckUpdate.js";
		
		int_finished=true;
		
		NextBillionTimer=window.clearInterval(NextBillionTimer);
		setIntervalTimer=window.clearInterval(setIntervalTimer);
		Popu.getPopulation(nTime,true);
	}

	
	//计算函数
	this.getPopulation=function (theTime,intNextBillion){
		var dIndex=parseInt((theTime.getFullYear()-1-1950)/5);
		var a=data.population[dIndex+1]/data.population[dIndex];
		var growthrate=Math.pow(a,1/5);
		var b=new Date();
		NextBillionCount=0;
		b.setUTCFullYear(dIndex*5+1950);
		b.setUTCMonth(11);
		b.setUTCDate(31);
		b.setUTCHours(23);
		b.setUTCMinutes(59);
		b.setUTCSeconds(59);
		b.setUTCMilliseconds(999);
		var c=(theTime.getTime()-b.getTime())/3600/1000/24/365.25;
		var PopulationCount=data.population[dIndex]*Math.pow(growthrate,c)*1000;
		var d=data.population[dIndex]*Math.pow(growthrate,((nTime.getTime()-b.getTime()+1000000)/3600/1000/24/365.25))*1000;
		onePeopleTime=1000000/(d-PopulationCount);
		PopulationCount=Math.round(PopulationCount);	

		if (intNextBillion) {
			Popu.setNextBillion(PopulationCount,growthrate);
		}
		nPopulation=PopulationCount;
		Popu.DisplayPopulationInit();
		return PopulationCount;
	}
	
	this.DisplayPopulationInit=function (){
		nPopulation+=1;
		//PopulationNumber.innerHTML=nPopulation;
		setIntervalTimer=setInterval(Popu.DisplayGrowth, Math.round(Math.abs(onePeopleTime)));
	}
	this.DisplayGrowth=function(){
		nPopulation+=1;
		if (L_localizedStrings_code=="zh-CHS"){
			PopulationNumber.innerHTML=Popu.format_number_zh_CHS(nPopulation);
		}else if(L_localizedStrings_code=="zh-CHT"){
			PopulationNumber.innerHTML=Popu.format_number_zh_CHT(nPopulation);
		}else if(L_localizedStrings_code=="ko"){
			PopulationNumber.innerHTML=Popu.format_number_ko(nPopulation);
		}else if(L_localizedStrings_code=="ja"){
			PopulationNumber.innerHTML=Popu.format_number_ja(nPopulation);
		}else{
			PopulationNumber.innerHTML=Popu.format_number(nPopulation);
		}
	}
	
	this.setNextBillion=function (Population,growthrate){
		if (data.country=="The World"){
			var nextBillion= parseInt(Population/100000000)+1;
			var years=Math.log(nextBillion*100000000/Population)/Math.log(growthrate);
			nextBillion=nextBillion/10
			NextBillionSeconds=Math.round(years*365.25*24*3600);
			try{
				if (L_localizedStrings_code=="zh-CHS"||L_localizedStrings_code=="zh-CHT"||L_localizedStrings_code=="ko"||L_localizedStrings_code=="ja"){
					//document.getElementById('NextBillionTitle').innerHTML=L_localizedStrings_NextBillion.replace("0",(nextBillion*10));
					NextBillionTitle.value=L_localizedStrings_NextBillion.replace("7",(nextBillion*10));
				}else{
					//document.getElementById('NextBillionTitle').innerHTML=L_localizedStrings_NextBillion.replace("0",nextBillion);
					NextBillionTitle.value=L_localizedStrings_NextBillion.replace("7",nextBillion);
				}
			}catch(err){}
			NextBillionTimer=setInterval(Popu.DisplayNextBillion, 1000);
			//document.getElementById('NextBillion').style.display="";
		}else{
			//document.getElementById('NextBillion').style.display="none";
			NextBillionTimer=window.clearInterval(NextBillionTimer);
		}
	}
	this.DisplayNextBillion=function (Population,growthrate){
		var b =NextBillionSeconds;
		var a;
		var t= "";	
			a=parseInt(b/86400);
			//t+=a+"<span class='NextBillionUnitUnDock'>days </span><span class='NextBillionUnitDock'>d </span>";
			//if (dock==1){t+=a+"days "}else{t+=a+"d "}
			t+=a+" "+L_localizedStrings_days+" ";
			b=b-a*86400;
			
			a=parseInt(b/3600);
			//t+=a+"<span class='NextBillionUnitUnDock'>hours </span><span class='NextBillionUnitDock'>:</span>";
			//if (dock==1){t+=a+" "+L_localizedStrings_hours+" "}else{if(a<10){t+="0"};t+=a+":"}
			if(a<10){t+="0"};t+=a+":";
			b=b-a*3600;			
			a=parseInt(b/60);
			//t+=a+"<span class='NextBillionUnitUnDock'>minutes </span><span class='NextBillionUnitDock'>:</span>";
			//if (dock==1){t+=a+" "+L_localizedStrings_minutes+" "}else{if(a<10){t+="0"};t+=a+":"}
			if(a<10){t+="0"};t+=a+":";
			b=b-a*60;

			//t+=b+"<span class='NextBillionUnitUnDock'>seconds</span><span class='NextBillionUnitDock'></span>";
			//if (dock==1){t+=b+" "+L_localizedStrings_seconds}else{if (b<10){t+="0"};t+=b}
			if (b<10){t+="0"};t+=b;
			
		//NextBillionTime.innerHTML=t;
		NextBillionTime.value=t;
		NextBillionSeconds-=1;
		NextBillionCount+=1;
		if ((NextBillionSeconds<1||NextBillionCount>120)&&onePeopleTime>0){
			NextBillionTimer=window.clearInterval(NextBillionTimer);
			setIntervalTimer=window.clearInterval(setIntervalTimer);
			nTime=new Date();
			nPopulation=Popu.getPopulation(nTime,true);
			
		}
	}
	this.IntGadgetObject=function (){
		NextBillionTitle=imgBackground.addTextObject("", "Segoe UI", 11, "Color(255, 255, 255, 255)", 0, 0);
		NextBillionTitle.align = 1;
		NextBillionTitle.addShadow("Color(255, 0, 0, 0)", 1, 100, 1, 1);
		NextBillionTitle.addGlow("Color(255, 0, 0, 0)", 1, 30);
		
		NextBillionTime=imgBackground.addTextObject("", "Segoe UI", 11, "Color(255, 255, 255, 255)", 0, 0);
		NextBillionTime.align = 1;  //Center
		NextBillionTime.addGlow("Color(255, 0, 0, 0)", 1, 30);
		NextBillionTime.addShadow("Color(255, 0, 0, 0)", 1, 100, 1, 1);
		
		tooltip=imgBackground.addTextObject("", "Segoe UI", 11, "Color(255, 255, 204, 0)", 0, 0);
		tooltip.align = 1;  //Center
		//tooltip.addShadow("Color(255, 0, 0, 0)", 1, 100, 1, 1);
		tooltip.addGlow("Color(255, 0, 0, 0)", 1, 62);
		//tooltip.opacity =80;

		//g_img_weblink=imgBackground.addImageObject("url(images/img3.gif)",1,9);
		//g_img_weblink.style.cursor="pointer";
		//g_img_weblink.onmouseover=Popu.Weblinkmouseover;
		//g_img_weblink.onmouseout=Popu.Weblinkmouseout;
		//g_img_weblink.onclick=Popu.WeblinkClick;
	}
	/*this.WeblinkClick=function (){
		System.Shell.execute("http://www.microsoft.com");
	}
	this.Weblinkmouseover=function (){
		g_img_weblink.src="url(images/button_more_hover.png)";
		Popu.ShowWeblinkTip();
	}
	this.Weblinkmouseout=function (){
		g_img_weblink.src="url(images/button_more.png)";
		Popu.HideTip();
	}*/
	
	this.format_number=function (n){ 
		var b=parseInt(n).toString(); 
		var len=b.length; 
		if(len<=3){return b;} 
		var r=len%3; 
		return r>0?b.slice(0,r)+"<span class='numberunit'> </span>"+b.slice(r,len).match(/\d{3}/g).join("<span class='numberunit'> </span>"):b.slice(r,len).match(/\d{3}/g).join("<span class='numberunit'> </span>"); 
	}
	this.format_number_zh_CHS=function (n){ 
		var b=parseInt(n).toString(); 
		var len=b.length; 
		if(len<=4){return b;} 
		var r=len%4;
		if(len<=8){
			return r>0?b.slice(0,r)+"<span class='numberunit'>万</span>"+b.slice(r,len):b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>万</span>");
		}else{
			return r>0?b.slice(0,r)+"<span class='numberunit'>亿</span>"+b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>万</span>"):b; 
		}
	} 
	this.format_number_zh_CHT=function (n){ 
		var b=parseInt(n).toString(); 
		var len=b.length; 
		if(len<=4){return b;} 
		var r=len%4;
		if(len<=8){
			return r>0?b.slice(0,r)+"<span class='numberunit'>萬</span>"+b.slice(r,len):b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>萬</span>");
		}else{
			return r>0?b.slice(0,r)+"<span class='numberunit'>億</span>"+b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>萬</span>"):b; 
		}
	} 
	this.format_number_ja=function (n){ 
		var b=parseInt(n).toString(); 
		var len=b.length; 
		if(len<=4){return b;} 
		var r=len%4;
		if(len<=8){
			return r>0?b.slice(0,r)+"<span class='numberunit'>万</span>"+b.slice(r,len):b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>万</span>");
		}else{
			return r>0?b.slice(0,r)+"<span class='numberunit'>億</span>"+b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>万</span>"):b; 
		}
	}
	this.format_number_ko=function (n){ 
		var b=parseInt(n).toString(); 
		var len=b.length; 
		if(len<=4){return b;} 
		var r=len%4;
		if(len<=8){
			return r>0?b.slice(0,r)+"<span class='numberunit'>만</span>"+b.slice(r,len):b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>만</span>");
		}else{
			return r>0?b.slice(0,r)+"<span class='numberunit'>억</span>"+b.slice(r,len).match(/\d{4}/g).join("<span class='numberunit'>만</span>"):b; 
		}
	}
}

//常数



var StringGadgetFont="<zh-CHS>Microsoft Yahei</zh-CHS>	<zh-CHT>Microsoft JhengHei</zh-CHT> <ja>Meiryo UI</ja>	<ko>Malgun Gothic</ko>";
//var StringWeblinkCode="<zh-CHS></zh-CHS>	<zh-CHT></zh-CHT>	<ar></ar>	<bg></bg>	<cs></cs>	<da></da>	<de></de>	<el></el>	<es></es>	<et></et>	<fi></fi>	<fr></fr>	<he></he>	<hr></hr>	<hu></hu>	<it></it>	<ja></ja>	<ko></ko>	<lt></lt>	<lv></lv>	<no></no>	<nl></nl>	<pl></pl>	<pt></pt>	<ro></ro>	<ru></ru>	<sk></sk>	<sl></sl>	<sv></sv>	<th></th>	<tr></tr>	<uk></uk>";


//全局变量
var data={country:"The World",population:[2529345.718,2763453.342,3023357.827,3331670.389,3685776.617,4061316.786,4437609.074,4846247.028,5290451.581,5713072.947,6115367.178,6512276.299,6908688.378,7302186.263,7674832.568,8011533.231,8308895.223,8570569.634,8801196.195,8996344.454,9149984.24],
			birthRate:[37.153,35.287,34.922,33.423,30.816,28.434,27.863,27.26,24.724,22.523,21.208,20.286,19.411,18.224,16.913,15.795,15.019,14.522,14.01,13.409]};

var nPopulation,NextBillionSeconds,onePeopleTime,NextBillionCount;
var setIntervalTimer,NextBillionTimer;
var PopulationNumber=document.getElementById('PopulationNumber');
//var NextBillionTime=document.getElementById('NextBillionTime');
var NextBillionTime,NextBillionTitle,tooltip;
var haveUpdate=false;

var dock=-1;
var int_finished=false;
var nTime=new Date();

//haveUpdate=true;